angular.module('manageListsApp', [
    'ngRoute',
    'manageSegments',
    'manageProfiles',
    'wemServices',
    'wemDirectives',
    'i18n'
])
    .config(['$routeProvider',
        function($routeProvider) {
            $routeProvider.
                when('/lists', {
                    templateUrl: ManagersContext.localTemplatesPath + '/segments/segment-list.html',
                    controller: 'ManageSegmentsListCtrl',
                    reloadOnSearch: false
                }).
                when('/list/:listId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/segments/segment-edit.html',
                    controller: 'ManageSegmentsCtrl',
                    resolve: {
                        // resolve rule here to avoid async issue using deferred API
                        "currentSegment": function( $q, $route, listService) {
                            var list = $q.defer();
                            listService.getList($route.current.params.listId).success(function (listData) {
                                list.resolve(listData);
                            });
                            return list.promise;
                        },
                        "newSegment": function () {
                            return false;
                        }
                    }
                }).
                when('/newList', {
                    templateUrl: ManagersContext.localTemplatesPath + '/segments/segment-edit.html',
                    controller: 'ManageSegmentsCtrl',
                    resolve: {
                        "currentSegment": function () {
                            return {
                                metadata: {
                                    id: ManagersUtils.generateId(),
                                    scope: ManagersContext.dmfScope,
                                    enabled: true
                                }
                            };
                        },
                        "newSegment": function () {
                            return true;
                        }
                    }
                }).
                when('/list/:listId/profiles', {
                    templateUrl: ManagersContext.localTemplatesPath + '/segments/profiles-list.html',
                    controller: function($scope, profileService) {
                        $scope.exportProfiles = function() {
                            var stringifyQuery = JSON.stringify(angular.copy(profileService.constructQueryOnCurrentSelectedTab(null, 0, -1, null)));
                            profileService.exportUsingForm(stringifyQuery, "list", "GET");
                        };

                        $scope.profileType='list';
                    }
                }).
                when('/list/:listId/profile/:profileId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-view.html',
                    controller: 'ManageProfileCtrl',
                    resolve: {
                        // resolve profile here to avoid async issue using deferred API
                        "profile": function ($q, $route, profileService) {
                            var profile = $q.defer();
                            profileService.getProfile($route.current.params.profileId).success(function (profileData) {
                                profile.resolve(profileData);
                            });
                            return profile.promise;
                        }
                    }
                }).
                when('/list/:listId/profile/:profileId/:sessionId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-session.html',
                    controller: 'ManageSessionCtrl'
                }).

                otherwise({
                    redirectTo: '/lists'
                });
        }])
;
