angular.module('manageRulesApp', [
    'ngRoute',
    'manageRules',
    'wemServices',
    'wemDirectives'
])
    .config(['$routeProvider',
    function($routeProvider) {
        $routeProvider.
            when('/rules', {
                templateUrl: ManagersContext.localTemplatesPath + '/rules/rule-list.html',
                controller: 'ManageRulesListCtrl'

            }).
            when('/rule/:ruleId', {
                templateUrl: ManagersContext.localTemplatesPath + '/rules/rule-edit.html',
                controller: 'ManageRulesCtrl',
                resolve: {
                    // resolve rule here to avoid async issue using deferred API
                    "currentRule": function( $q, $route, ruleService) {
                        var rule = $q.defer();
                        ruleService.getRule($route.current.params.ruleId).success(function(ruleData){
                            rule.resolve(ruleData);
                        });
                        return rule.promise;
                    }
                }
            }).
            otherwise({
                redirectTo: '/rules'
            });
    }])
;
