<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContextreste" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>


<jsp:include page="../../commons/adminBaseImports.jsp"/>

<template:addResources type="javascript" resources="angular-simple-logger.js,
                                                    angular-google-maps.js,
                                                    angular-cookies.js,
                                                    wem-persona-panel.js"/>

<template:addResources type="css" resources="mf-preview-panel.css"/>

<div ng-app="wemPersonaPanelApp">

    <div ng-controller="panelController">



        <div class="testContainer">

        <ul class="tabs" role="tablist">
            <li>
                <input type="radio" name="tabs" id="tab1" checked />
                <label class="tabLabel" for="tab1" role="tab" aria-selected="true" aria-controls="panel1"><fmt:message key="jnt_template.personas.tab.perso"/></label>
                <div id="tab-content1" class="tab-content" role="tabpanel" aria-hidden="false">
                    <header class="pageHead ng-scope ng-isolate-scope">
                        <h2 style="display: inline; margin: 0 5px 0 5px;"><fmt:message key="jnt_template.personas.title"/> :
                            <select class="form-control" style="width: 45%; display: inline;"
                                    ng-model="selectedPersona"
                                    ng-options="persona.itemId as persona.displayName for persona in personas.list"
                                    ng-change="personaSelected()"></select></h2>
                        <button class="btn btn-default" ng-click="resetPersona()" ng-show="hasOverridePersona()"><i class="material-icons">restore</i></button>
                    </header>


                    <div class="baseSetCard light-grey-bg" style="height: 88%">

                        <div class="box-3-text-container clearfix">
                            <form name="mapping" ng-submit="updatePersonaOverride()" novalidate="novalidate">
                                <div class="row">
                                    <div ng-if="selectedPersona != 'none'">
                                        <div class="formmapcatsep">
                                            <fieldset>
                                                <div class="box-3-title-container">
                                                    <legend>
                                                        <a class="btn btn-default" ng-click="tooglableClick('segments')">
                                                            <i class="material-icons">{{tooglable.segments?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                        </a>
                                                        <fmt:message key="jnt_template.personas.segments"/>
                                                    </legend>
                                                </div>

                                                <div class="card-content-container" ng-show="tooglable.segments">
                                                    <div class="form-group col-md-12" ng-repeat="segmentValue in profileSegments" ng-class="{filterTarget: isFilterOnTarget('profile.segments', segmentValue)}">
                                                        <input type="text" value="{{getSegmentName(segmentValue)}}" disabled>
                                                        <a class="btn btn-default removeProp" ng-click="removeSegment(segmentValue)">
                                                            <i class="material-icons">remove_circle_outline</i>
                                                        </a>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-show="propertiesHandler.addSegment">
                                                        <select ng-model="propertiesHandler.segmentsToAdd" class="form-control segment"
                                                                ng-options="segment as segment.name for segment in allSegments |filter:filterAvailableSegments"
                                                                multiple></select>
                                                        <a class="btn btn-default" ng-click="addSegments()"><i class="material-icons">check_circle</i></a>
                                                    </div>

                                                    <div ng-show="!propertiesHandler.addSegment">
                                                        <a class="btn btn-default" ng-click="propertiesHandler.addSegment = true"><i class="material-icons">add_circle</i></a>
                                                    </div>
                                                </div>
                                            </fieldset>
                                        </div>

                                        <div class="formmapcatsep">
                                            <fieldset>
                                                <div class="box-3-title-container">
                                                    <legend>
                                                        <a class="btn btn-default" ng-click="tooglableClick('interests')">
                                                            <i class="material-icons">{{tooglable.interests?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                        </a>
                                                        <fmt:message key="jnt_template.personas.interests"/>
                                                    </legend>
                                                </div>

                                                <div class="card-content-container" ng-show="tooglable.interests">
                                                    <div class="form-group col-md-12" ng-repeat="(name, value) in profileProperties.interests">
                                                        <foldable-input model="profileProperties.interests[name]" label="{{name}}" type="number"></foldable-input>
                                                        <a class="btn btn-default removeProp" ng-click="removeProp(name, 'interest')">
                                                            <i class="material-icons">remove_circle_outline</i>
                                                        </a>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-show="propertiesHandler.addInterest">
                                                        <foldable-input model="propertiesHandler.interestToAdd" label="name" type="text"></foldable-input>
                                                        <foldable-input model="propertiesHandler.interestToAddValue" label="value" type="number"></foldable-input>
                                                        <a class="btn btn-default" ng-click="addInterest()">
                                                            <i class="material-icons">check_circle</i>
                                                        </a>
                                                    </div>

                                                    <div ng-show="!propertiesHandler.addInterest">
                                                        <a class="btn btn-default" ng-click="propertiesHandler.addInterest = true"><i class="material-icons">add_circle</i></a>
                                                    </div>
                                                </div>
                                            </fieldset>
                                        </div>

                                        <div class="formmapcatsep">
                                            <fieldset ng-if="availableProfileProperties">
                                                <div class="box-3-title-container">
                                                    <legend>
                                                        <a class="btn btn-default" ng-click="tooglableClick('profile')">
                                                            <i class="material-icons">{{tooglable.profile?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                        </a>
                                                        <fmt:message key="jnt_template.personas.all_properties"/>
                                                    </legend>
                                                </div>

                                                <div class="card-content-container" ng-show="tooglable.profile">
                                                    <div class="form-group col-md-12" ng-repeat="name in filteredEditableProp('profile')"
                                                         ng-class="{filterTarget: isFilterOnTarget('profile.properties.' + name)}">
                                                        <foldable-input name="profile.{{name}}" model="profileProperties[name]" label-key="profilesProperty.{{name}}"
                                                                        label="{{getPropertyName('profile', name)}}" type="{{getPropertyInputType(name, 'profile')}}" ng-if="!choiceListValues.profile[name]"></foldable-input>
                                                        <div class="group" ng-if="choiceListValues.profile[name]">
                                                            <select name="profile.{{name}}"
                                                                    ng-model="profilesProperty[name]"
                                                                    ng-options="value as value for value in choiceListValues.profile[name]"
                                                                    ng-change="updatePersonaOverride()"
                                                            >
                                                            </select>
                                                            <label class="foldedLabel" message-key="profileProperties.{{name}}"></label>
                                                        </div>
                                                        <a class="btn btn-default removeProp" ng-click="removeProp(name, 'profile')">
                                                            <i class="material-icons">remove_circle_outline</i>
                                                        </a>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-show="propertiesHandler.addProfileProperties">
                                                        <select class="form-control"
                                                                ng-model="propertiesHandler.profilePropertyToAdd"
                                                                ng-options="property.metadata.name for property in availableProfileProperties |filter:filterAvailableProps"
                                                                ng-change="addProfileProp()"></select>
                                                    </div>

                                                    <div ng-show="!propertiesHandler.addProfileProperties">
                                                        <a class="btn btn-default" ng-click="propertiesHandler.addProfileProperties = true">
                                                            <i class="material-icons">add_circle</i>
                                                        </a>
                                                    </div>
                                                </div>
                                            </fieldset>
                                        </div>

                                        <div class="formmapcatsep">
                                            <fieldset ng-if="availableSessionProperties">
                                                <div class="box-3-title-container">
                                                    <legend>
                                                        <a class="btn btn-default" ng-click="tooglableClick('session')">
                                                            <i class="material-icons">{{tooglable.session?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                        </a>
                                                        <fmt:message key="jnt_template.personas.session_properties"/>
                                                    </legend>
                                                </div>

                                                <div class="card-content-container" ng-show="tooglable.session">
                                                    <div class="form-group col-md-12" ng-repeat="name in filteredEditableProp('session')"
                                                         ng-class="{filterTarget: isFilterOnTarget('profile.properties.' + name)}" ng-switch on="name">
                                                        <foldable-input name="session.{{name}}" model="sessionProperties[name]" label-key="sessionProperties.{{name}}"
                                                                        label="{{getPropertyName('session', name)}}" type="{{getPropertyInputType(name, 'session')}}" ng-if="!choiceListValues.session[name]"></foldable-input>
                                                        <div class="group" ng-if="choiceListValues.session[name]">
                                                            <select name="session.{{name}}"
                                                                    ng-model="sessionProperties[name]"
                                                                    ng-options="value as value for value in choiceListValues.session[name]"
                                                                    ng-change="updatePersonaOverride()"
                                                            >
                                                            </select>
                                                            <label class="foldedLabel" message-key="sessionProperties.{{name}}"></label>
                                                        </div>
                                                        <a class="btn btn-default removeProp" ng-click="removeProp(name, 'session')">
                                                            <i class="material-icons">remove_circle_outline</i>
                                                        </a>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-show="propertiesHandler.addSessionProperties">
                                                        <select class="form-control"
                                                                ng-model="propertiesHandler.sessionPropertyToAdd"
                                                                ng-options="property.metadata.name for property in availableSessionProperties |filter:filterAvailableProps"
                                                                ng-change="addSessionProp()"></select>
                                                    </div>


                                                    <div ng-show="!propertiesHandler.addSessionProperties">
                                                        <a class="btn btn-default" ng-click="propertiesHandler.addSessionProperties = true">
                                                            <i class="material-icons">add_circle</i>
                                                        </a>
                                                    </div>
                                                </div>
                                            </fieldset>
                                        </div>

                                        <div class="formmapcatsep">
                                            <fieldset>
                                                <div class="box-3-title-container">
                                                    <legend>
                                                        <a class="btn btn-default" ng-click="tooglableClick('location')">
                                                            <i class="material-icons">{{tooglable.location?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                        </a>
                                                        <fmt:message key="jnt_template.personas.locations"/>
                                                    </legend>
                                                </div>

                                                <div class="card-content-container" ng-show="tooglable.location">
                                                    <div class="form-group col-md-12" ng-class="{filterTarget: isFilterOnTarget('session.sessionCountryName')}">
                                                        <span>{{getPropertyResourceName("session","sessionCountryName")}}</span>
                                                        <div ng-show="locationHandler.countryLoaded">
                                                            <select ng-model="sessionProperties['sessionCountryName']"
                                                                    class="form-control"
                                                                    ng-options="country.name as country.name for country in countries"
                                                                    required="true"
                                                                    ng-change="locationEdited('sessionCountryName')">
                                                            </select>
                                                            <div class="flag flag-{{sessionProperties.sessionCountryCode.toLowerCase()}}" ng-if="sessionProperties['sessionCountryName']"/>
                                                        </div>
                                                        <svg class="loadingSpinnerPersona" height="50" width="50" ng-show="!locationHandler.countryLoaded">
                                                            <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                    stroke-width="6" stroke-miterlimit="10"/>
                                                        </svg>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-class="{filterTarget: isFilterOnTarget('session.sessionAdminSubDiv1')}" ng-show="adm1List"
                                                         ng-if="sessionProperties['sessionCountryName']">
                                                        <span>{{getPropertyResourceName("session","sessionAdminSubDiv1")}}</span>
                                                        <div ng-show="locationHandler.adm1Loaded">
                                                            <select ng-model="sessionProperties.sessionAdminSubDiv1"
                                                                    class="form-control"
                                                                    ng-options="adm1.itemId as adm1.name for adm1 in adm1List"
                                                                    required="true"
                                                                    ng-change="locationEdited('sessionAdminSubDiv1')">
                                                            </select>
                                                        </div>
                                                        <div  ng-show="!locationHandler.adm1Loaded">
                                                            <svg class="loadingSpinnerPersona" height="50" width="50">
                                                                <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                        stroke-width="6" stroke-miterlimit="10"/>
                                                            </svg>
                                                        </div>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-class="{filterTarget: isFilterOnTarget('session.sessionAdminSubDiv2')}" ng-show="adm2List && sessionProperties['sessionCountryName']">
                                                        <span>{{getPropertyResourceName("session","sessionAdminSubDiv2")}}</span>
                                                        <div ng-show="locationHandler.adm2Loaded">
                                                            <select ng-model="sessionProperties.sessionAdminSubDiv2"
                                                                    class="form-control"
                                                                    ng-options="adm2.itemId as adm2.name for adm2 in adm2List"
                                                                    required="true"
                                                                    ng-change="locationEdited('sessionAdminSubDiv2')">
                                                            </select>
                                                        </div>
                                                        <svg class="loadingSpinnerPersona" height="50" width="50"
                                                             ng-show="!locationHandler.adm2Loaded">
                                                            <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                    stroke-width="6" stroke-miterlimit="10"/>
                                                        </svg>
                                                    </div>

                                                    <div class="form-group col-md-12" ng-class="{filterTarget: isFilterOnTarget('session.' + sessionCity)}" ng-show="cities.length>0 && sessionProperties['sessionCountryName']">
                                                        <span>{{getPropertyResourceName("session","sessionCity")}}</span>
                                                        <div ng-show="locationHandler.cityLoaded">
                                                            <select ng-model="sessionProperties.sessionCityId"
                                                                    class="form-control"
                                                                    ng-options="city.itemId as city.name for city in cities"
                                                                    required="true"
                                                                    ng-change="locationEdited('sessionCityId')">
                                                            </select>
                                                        </div>
                                                        <svg class="loadingSpinnerPersona" height="50" width="50"
                                                             ng-show="!locationHandler.cityLoaded">
                                                            <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                    stroke-width="6" stroke-miterlimit="10"/>
                                                        </svg>
                                                    </div>

                                                    <div style="height:300px; margin-left: -33px; margin-right: -33px">
                                                        <ui-gmap-google-map
                                                                center="map.center"
                                                                zoom="map.zoom"
                                                                control="map.control"
                                                                options="map.options"
                                                                pan="true">
                                                            <ui-gmap-marker coords="marker.coords" options="marker.options" events="marker.events"
                                                                            idkey="marker.id">
                                                            </ui-gmap-marker>
                                                        </ui-gmap-google-map>
                                                    </div>
                                                </div>
                                            </fieldset>
                                        </div>
                                        <input type="submit"
                                               style="position: absolute; left: -9999px; width: 1px; height: 1px;"
                                               tabindex="-1" />
                                    </div>
                                    <div ng-if="selectedPersona == 'none'">
                                        <div>
                                            <fieldset>
                                                <div class="box-3-title-container">
                                                    <legend class="warnMessage">
                                                        <fmt:message key="persona.panel.please.select.to.edit"/>
                                                    </legend>
                                                </div>
                                            </fieldset>
                                        </div>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </li>
            <li>
                <input type="radio" name="tabs" id="tab2" />
                <label class="tabLabel" for="tab2"role="tab" aria-selected="false" aria-controls="panel2"><fmt:message key="jnt_template.personas.tab.optitests"/></label>
                <div id="tab-content2" class="tab-content" role="tabpanel" aria-hidden="true">
                    <div class="baseSetCard light-grey-bg" style="height: 88%">

                        <div class="box-3-text-container clearfix" ng-if="pageVariants">
                            <div class="row">
                                <div>
                                    <div class="formmapcatsep">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="tooglableClick('optimizationPage')">
                                                        <i class="material-icons">{{tooglable.optimizationPage?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.optipage"/>
                                                </legend>
                                            </div>

                                            <div ng-show="tooglable.optimizationPage">
                                                <div class="form-group col-md-12">
                                                    <select ng-model="variantToApply" class="form-control segment"
                                                            ng-options="pageVariant.name as pageVariant.title for pageVariant in pageVariants"
                                                            ng-change="reloadWithSelectedVariant(variantToApply)"></select>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="box-3-text-container clearfix" ng-if="areas">
                            <div class="row">
                                <div>
                                    <div class="formmapcatsep">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="tooglableClick('optimizationContent')">
                                                        <i class="material-icons">{{tooglable.optimizationContent?'arrow_drop_up':'arrow_drop_down'}}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.opticontent"/>
                                                </legend>
                                            </div>

                                            <div ng-show="tooglable.optimizationContent">
                                                <div class="form-group col-md-12" ng-repeat="(key, value) in areas">
                                                    <label class="foldedLabel">{{value.name}}</label>
                                                    <select ng-model="contentVariantToApply[key]" class="form-control segment"
                                                            ng-options="contentVariant.content as contentVariant.name for contentVariant in value.variants"
                                                            ng-change="reloadWithSelectedContentVariant(key)"></select>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div ng-if="!pageVariants && !areas">
                            <div>
                                <fieldset>
                                    <div class="box-3-title-container">
                                        <legend class="warnMessage">
                                            <fmt:message key="persona.panel.opti.notFound"/>
                                        </legend>
                                    </div>
                                </fieldset>
                            </div>
                        </div>

                    </div>
                </div>
            </li>
        </ul>

        </div>


    </div>
</div>